         title   AppLoad

         .586
         .model flat, stdcall
         option casemap:none   ; Case sensitive

            include  Windows.inc
            include  user32.inc
            include  kernel32.inc
            include  gdi32.inc
            include  comctl32.inc
            include  comdlg32.inc
            include  shell32.inc

   include  L:\AsmEdit\include\DSPMACRO.asm

         includelib  user32.lib
         includelib  kernel32.lib
         includelib  gdi32.lib
         includelib  comctl32.lib
         includelib  comdlg32.lib
         includelib  shell32.lib

;===================================================
; PROTO, MACRO, and Data section
;===================================================
WinMain         PROTO  :DWORD, :DWORD, :DWORD, :DWORD
ListboxProc     PROTO  :DWORD, :DWORD, :DWORD, :DWORD
TabCtlDlg       PROTO  :DWORD, :DWORD, :DWORD, :DWORD
MaintDlg        PROTO  :DWORD, :DWORD, :DWORD, :DWORD
EnumWindowCallBack  PROTO  :DWORD, :DWORD

TBSep    MACRO hTool
           mov     tbb.iBitmap, 0
           mov     tbb.idCommand, 0
           mov     tbb.fsState, TBSTATE_ENABLED
           mov     tbb.fsStyle, TBSTYLE_SEP
        INVOKE     SendMessage, hTool, TB_ADDBUTTONS, 1, addr tbb
          ENDM

TBButt   MACRO hTool, BmpID, CmdID, Text
           mov     tbb.iBitmap, BmpID    ; Button image number
           mov     tbb.idCommand, CmdID  ; Command ID number
           mov     tbb.fsState, TBSTATE_ENABLED
           mov     tbb.fsStyle, TBSTYLE_BUTTON
           mov     tbb.dwData, 0
           mov     tbb.iString, Text
        INVOKE     SendMessage, hTool, TB_ADDBUTTONS, 1, addr tbb
          ENDM

MOVmd    MACRO Var1, Var2
          push     Var2
           pop     Var1
          ENDM

.const
IDM_MENU       equ 9000
IDM_CUST       equ 9001
IDM_ABOUT      equ 9002
IDM_EXIT       equ 9003

.data
AppName        db  'AppLoad',0
MenuName       db  'MainMenu',0
PopupMenu      db  'PopupMenu',0
ClassName      db  'AppLoad',0
ToolClass      db  'ToolbarWindow32',0
ListboxClass   db  'listbox',0
FontMS         db  'MS Sans Serif',0

szClassName      db  'AsmEdit V5.0',0

TabTitle1      db  'Toolbar',0
TabTitle2      db  'Menu',0
TabTitle3      db  'Options',0

szButText      db  'Update',0

szAppLoad      db  'AppLoad.ini',0
szToolbars     db  'ToolbarOrder',0
szMenus        db  'MenuOrder',0
szOptions      db  'Options',0
szImageInfo    db  'ImageInfo',0

szKeyTool      db  'Tool',0
szKeyMenu      db  'Menu',0
szKeyFlat      db  'FlatButtons',0
szKeyOnTop     db  'AlwaysOnTop',0
szKeyShow      db  'ShowToolTip',0
szKeyTop       db  'TopPos',0
szKeyRight     db  'RightPos',0

szSep          db  '---- (Separator) ----',0
szUse          db  'Use Application Image',0
szEdit         db  'Edit The Program Item',0

AboutMsg       db  'Pgm Launcher', 13, 10, 'Copyright  2004 Ewayne Wagner',0
szMsg01        db  'Are you sure that you want to',0dh,0ah
               db  'delete this application?',0
szMsg02        db  'Missing Field(s)!',0
szMsg03        db  'There were changes made would you',0dh,0ah
               db  'like to go back and do the updates?',0

szOpen         db  'open',0
szOpenTitle    db  'Open File',0
szImage        db  'Image Files (ico),(bmp)',0,'*.ico;*.bmp',0,
                   'All Files',0,'*.*',0,0

szExec         db  'Exec Files (*.exe)',0,'*.exe',0,
                   'All Files',0,'*.*',0,0

szNULL         db  0,0
szEqu          db  '=',0
szComma        db  ',',0
szAstr         db  '*',0
szZero         db  '0',0
fmat1          db  '%01u',0
szIco          db  '.ico',0
szBmp          db  '.bmp',0
szAll          db  '*.*',0
szImage0       db  ',0',0
szImage1       db  ',1',0

.data?
hInst          dd  ?
CommandLine    dd  ?
MainExit       dd  ?
hWnd           dd  ?
hWndTool       dd  ?
hPopupMenu     dd  ?
hSMenu         dd  ?
hDlg           dd  ?
hTab           dd  ?
hList01        dd  ?
hList02        dd  ?
hListBox01     dd  ?
hListBox02     dd  ?
SubListbox     dd  ?
hComboBox01    dd  ?
hList          dd  ?
hListH         dd  ?
CurSelect      dd  ?
TabSelect      dd  ?
hTabSeL1       dd  ?
hTabSeL2       dd  ?
hTabSeL3       dd  ?
hTempBU        dd  ?
hTempBD        dd  ?
hIcon          dd  ?
hFontL         dd  ?
hImageList01   dd  ?
hUpdate        dd  3    dup(?)
SubButtbox     dd  ?
LastForeWindow dd  ?

FlatButtons    dd  ?
AlwaysOnTop    dd  ?
ShowToolTip    dd  ?
TopPos         dd  ?
RightPos       dd  ?

AddOn          dd  ?
MenuOn         dd  ?
ImageOn        dd  ?
ChangeOn       dd  ?
UpdateOn       dd  3    dup(?)
ToolCnt        dd  ?
dwStyle        dd  ?
ToolTop        dd  ?
ListNum        dd  ?
NextLast       dd  ?

RootDir        db  256  dup(?)
szWork         db  256  dup(?)
szImageFile    db  256  dup(?)
szAppPath      db  256  dup(?)
szKeyName      db  32   dup(?)

Test4          dd  ?

;---------- [Structures] ----------
tci            TC_ITEM          <?>
dis            DRAWITEMSTRUCT   <>

.code

;===================================================
; Program initialization section
;===================================================
start:
      INVOKE     GetModuleHandle, NULL
         mov     hInst, eax

      INVOKE     GetCommandLine
         mov     CommandLine, eax
      INVOKE     lstrcpy, addr szWork, CommandLine
      INVOKE     lstrcpy, addr RootDir, CommandLine

      .if byte ptr szWork == '"'
         INVOKE     lstrlen, addr szWork
            sub     eax, 2
         INVOKE     lstrcpyn, addr RootDir, addr szWork+1, eax
      .endif
      INVOKE     lstrlen, addr RootDir
         lea     edx, RootDir
      .while (eax)
            dec     eax
         .if byte ptr [edx+eax] == '\'
               mov     byte ptr[edx+eax+1], 0
            .break
         .endif
      .endw

        call     InitCommonControls

      INVOKE     WinMain, hInst ,NULL, CommandLine, SW_SHOWDEFAULT
         mov     MainExit, eax
      INVOKE     ExitProcess, MainExit

;===================================================
; WinMain procedure
;===================================================
WinMain proc  uses ebx  hinst:DWORD, hPrevInst, CmdLine, CmdShow
LOCAL    wc:WNDCLASSEX
LOCAL    msg:MSG

         mov     wc.cbSize, sizeof WNDCLASSEX
         mov     wc.style, CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW
         mov     wc.lpfnWndProc, offset WndProc
         mov     wc.cbClsExtra, NULL
         mov     wc.cbWndExtra, NULL
        push     hInst
         pop     wc.hInstance
         mov     wc.hbrBackground, COLOR_BTNFACE+1
         mov     wc.lpszMenuName, 0
         mov     wc.lpszClassName, offset ClassName
      INVOKE     LoadIcon, NULL, IDI_APPLICATION
         mov     wc.hIcon, 0
         mov     wc.hIconSm, 0
      INVOKE     LoadCursor, NULL, IDC_ARROW
         mov     wc.hCursor, eax
      INVOKE     RegisterClassEx, addr wc

      INVOKE     LoadMenu, hInst, addr PopupMenu
         mov     hPopupMenu, eax
      INVOKE     GetSubMenu, eax, 0
         mov     hSMenu, eax

;---------- [Create the Main Window] ----------
      INVOKE     CreateWindowEx, WS_EX_TOOLWINDOW or WS_EX_TOPMOST, addr ClassName, NULL,\
                 WS_POPUP or WS_VISIBLE,\
                 300, 100, 200, 18, NULL, NULL, hInst, NULL
         mov     hWnd, eax

      INVOKE     ShowWindow, hWnd, SW_SHOWNORMAL
      INVOKE     UpdateWindow, hWnd
INVOKE     keybd_event, VK_MENU, 0, 0, 0                 ; press Alt
INVOKE     keybd_event, VK_ESCAPE, 0, 0, 0               ; press Space
INVOKE     keybd_event, VK_ESCAPE, 0, KEYEVENTF_KEYUP, 0 ; release Escape
INVOKE     keybd_event, VK_MENU, 0, KEYEVENTF_KEYUP, 0   ; release Alt

;---------- [Message loop] ----------
      .while TRUE
         INVOKE     GetMessage, addr msg, NULL, 0, 0
         .break .if (!eax)
         INVOKE     IsDialogMessage, hTabSeL1, addr msg
            cmp     eax, 0
            jne     Pass
         INVOKE     IsDialogMessage, hTabSeL2, addr msg
            cmp     eax, 0
            jne     Pass
         INVOKE     IsDialogMessage, hTabSeL3, addr msg
            cmp     eax, 0
            jne     Pass
         INVOKE     TranslateMessage, addr msg
         INVOKE     DispatchMessage, addr msg

Pass:
      .endw
         mov     eax, msg.wParam
         ret
WinMain endp

;===================================================
; WinProc procedure
;===================================================
WndProc proc uses ebx esi edi hwnd:DWORD, wMsg, wParam, lParam
LOCAL    lf:LOGFONT
LOCAL    rect:RECT
LOCAL    szAppName[32]:BYTE, szBuff1[32]:BYTE, szBuff2[256]:BYTE, szBuff3[256]:BYTE

;---------- [Create the Control(s) and one time stuff] ----------
      .if wMsg == WM_CREATE
            mov     eax, hwnd
            mov     hWnd, eax
         INVOKE     lstrcpy, addr szAppPath, addr RootDir
         INVOKE     lstrcat, addr szAppPath, addr szAppLoad

            mov     FlatButtons, 1
            mov     AlwaysOnTop, 1
            mov     ShowToolTip, 1
            mov     TopPos, 0
            mov     RightPos, 54
           call     GetOptions
            mov     ToolTop, -2
         .if !FlatButtons
               mov     ToolTop, -4
         .endif
;DSPValue hWnd, TopPos, 1, 'm'

         INVOKE     LoadIcon, hInst, 500
            mov     hIcon, eax

         INVOKE     RtlZeroMemory, addr lf, sizeof lf
         INVOKE     lstrcpy, addr lf.lfFaceName, addr FontMS
            mov     lf.lfHeight, -12
            mov     lf.lfWeight, 500
         INVOKE     CreateFontIndirect, addr lf
            mov     hFontL, eax   ; Listbox font

;---------- [Create the Toolbar Window] ---------- 
            mov     ecx, WS_CHILD or WS_VISIBLE or CCS_NODIVIDER or CCS_NOPARENTALIGN or CCS_TOP
            mov     dwStyle, ecx
         .if FlatButtons
                or     ecx, TBSTYLE_FLAT
                or     ecx, TBSTYLE_TRANSPARENT
         .endif
         .if ShowToolTip
                or     ecx, TBSTYLE_TOOLTIPS
         .endif
         INVOKE     CreateWindowEx, NULL, addr ToolClass, NULL,\
                    ecx,\
                    0, 0, 0, 0, hwnd, 2001, hInst, NULL
            mov     hWndTool, eax

           call     UpdateTool
           call     UpdateMenu

;---------- [Move and Size the Control(s)] ----------
      .elseif wMsg == WM_SIZE
         INVOKE     SendMessage, hWndTool, TB_BUTTONCOUNT, 0, 0
           push     eax
            mov     ecx, eax
            dec     ecx
         INVOKE     SendMessage, hWndTool, TB_GETITEMRECT, ecx, addr rect
            pop     eax
            mov     edi, rect.right
            sub     edi, rect.left
           imul     edi, eax

           call     GetDesktopWindow
            mov     ebx, eax
         INVOKE     GetWindowRect, ebx, addr rect
           push     rect.right
         INVOKE     GetClientRect, hWnd, addr rect
            mov     rect.right, edi
            mov     eax, rect.right
            pop     ebx
            sub     ebx, eax
            sub     ebx, RightPos
         INVOKE     MoveWindow, hwnd, ebx, TopPos, rect.right, rect.bottom, TRUE ;80
            sub     rect.right, edi
         INVOKE     MoveWindow, hWndTool, rect.right, ToolTop, edi, 18, TRUE ;, 0, edi, 20

;      .elseif wMsg == WM_ACTIVATE && wParam == WA_ACTIVE
;;INVOKE     SetFocus, lParam
;.if Test4
;;DSPValue hWnd, lParam, 1, 'm'
;.endif
;.if sdword ptr Test4 > 0 && !lParam
;   dec     Test4
;INVOKE     keybd_event, VK_MENU, 0, 0, 0                 ; press Alt
;INVOKE     keybd_event, VK_ESCAPE, 0, 0, 0               ; press Space
;INVOKE     keybd_event, VK_ESCAPE, 0, KEYEVENTF_KEYUP, 0 ; release Escape
;INVOKE     keybd_event, VK_MENU, 0, KEYEVENTF_KEYUP, 0   ; release Alt
;.endif

      .elseif wMsg == WM_NOTIFY
            mov     ebx, lParam                      ; Get pointer to NMHDR
            mov     eax, (NMHDR ptr [ebx]).code
         .if eax == TTN_NEEDTEXT && ShowToolTip
               mov     eax, (NMHDR ptr [ebx]).idFrom ; Resource id
            .if eax > 2000 && eax < 2100
               INVOKE     wsprintf, addr szBuff1, addr fmat1, eax
               INVOKE     lstrcpy, addr szAppName, addr szToolbars
               INVOKE     lstrcpy, addr szBuff2, addr szKeyTool
                 call     DoExtract
                  mov     ebx, lParam                ; Get the buffer addr
                  lea     eax, szBuff3
                  mov     (TOOLTIPTEXT ptr [ebx]).lpszText, eax

            .else
                  mov     ebx, eax
               INVOKE     LoadString, hInst, ebx, addr szBuff3, lengthof szBuff3
                  mov     ebx, lParam                ; Get the buffer addr
                  lea     eax, szBuff3
                  mov     (TOOLTIPTEXT ptr [ebx]).lpszText, eax
            .endif
               jmp     Ret0
         .endif
            jmp     DefWin

;---------- [System and user commands] ----------
      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
           cwde                                      ; Only low word contains command
         .if eax == IDM_MENU
            .if !MenuOn
               INVOKE     GetWindowRect, hWndTool, addr rect
               INVOKE     TrackPopupMenu, hSMenu, TPM_RIGHTALIGN or TPM_LEFTBUTTON,\
                          rect.right, rect.bottom, 0, hWnd, addr rect
            .endif
               xor     MenuOn, 1

         .elseif eax == IDM_CUST && !hDlg
            INVOKE     CreateDialogParam, hInst, 4800, hwnd, offset TabCtlDlg, 0
               mov     hDlg, eax

         .elseif eax == IDM_ABOUT
            INVOKE     ShellAbout, hWnd, addr AppName, addr AboutMsg, hIcon
               xor     MenuOn, 1

         .elseif eax == IDM_EXIT
            INVOKE     SendMessage, hWnd, WM_CLOSE, 0 ,0

         .elseif eax > 2000 && eax < 2100 || eax > 3000 && eax < 3100
              push     eax
            INVOKE     wsprintf, addr szBuff1, addr fmat1, eax
               pop     eax
            .if eax > 2000 && eax < 2100
               INVOKE     lstrcpy, addr szAppName, addr szToolbars
               INVOKE     lstrcpy, addr szBuff2, addr szKeyTool
            .else
                  xor     MenuOn, 1
               INVOKE     lstrcpy, addr szAppName, addr szMenus
               INVOKE     lstrcpy, addr szBuff2, addr szKeyMenu
            .endif
              call     DoExtract
               sub     eax, ecx
               sub     eax, 2
            INVOKE     lstrcpyn, addr szBuff2, addr szBuff3[ecx+1], eax

            INVOKE     lstrcpy, addr szBuff3, addr szBuff2
            INVOKE     lstrlen, addr szBuff3
            .while (eax)
                  dec     eax
               .if szBuff3[eax-1] == '\'
                  .break
               .endif
            .endw
               inc     eax
            INVOKE     lstrcpyn, addr szBuff3, addr szBuff3, eax
            INVOKE     SetCurrentDirectory, addr szBuff3
            INVOKE     ShellExecute, hWnd, addr szOpen, addr szBuff2, NULL, NULL, SW_SHOWNORMAL
;inc     Test4
         .endif

      .elseif wMsg == WM_CLOSE
         INVOKE     DestroyWindow, hWndTool
         INVOKE     DestroyWindow, hWnd

      .elseif wMsg == WM_DESTROY
         .if hTempBU
            INVOKE     DeleteObject, hTempBU
            INVOKE     DeleteObject, hTempBD
         .endif
         INVOKE     DeleteObject, hFontL
         INVOKE     DestroyIcon, hIcon
         INVOKE     DestroyMenu, hPopupMenu
         INVOKE     ImageList_Destroy, hImageList01
         INVOKE     PostQuitMessage, NULL

      .else

DefWin:
         INVOKE     DefWindowProc, hwnd, wMsg, wParam, lParam
            ret
      .endif

Ret0:
         xor    eax, eax
         ret

DoExtract:
      INVOKE     lstrcat, addr szBuff2, addr szBuff1
      INVOKE     GetPrivateProfileString, addr szAppName, addr szBuff2, addr szNULL,\
                 addr szBuff3, 256, addr szAppPath
         lea     edx, szBuff3
         xor     ecx, ecx
        push     eax
      .while (eax)
         .if byte ptr [edx+ecx] == ','
               mov     byte ptr[edx+ecx], 0
            .break
         .endif
            inc     ecx
            dec     eax
      .endw
         pop     eax
        retn

WndProc endp

;=======================================
; Button subclass procedure
;=======================================
ButtonProc PROC hwnd:DWORD, wMsg, wParam, lParam

      .if wMsg == WM_ERASEBKGND
            mov     eax, 1
            ret

      .else
         INVOKE     CallWindowProc, SubButtbox, hwnd, wMsg, wParam, lParam
            ret
      .endif

ButtonProc ENDP

;=======================================
; Listbox subclass procedure
;=======================================
ListboxProc PROC hwnd:DWORD, wMsg, wParam, lParam

      .if wMsg == WM_ERASEBKGND
            mov     eax, 1
            ret

      .else
         INVOKE     CallWindowProc, SubListbox, hwnd, wMsg, wParam, lParam
            ret
      .endif

ListboxProc ENDP

;=======================================
; Get Options procedure
;=======================================
GetOptions PROC uses ebx esi edi
LOCAL    szBuff2[32]:BYTE

         xor     ebx, ebx
         mov     szBuff2, 0
      INVOKE     GetPrivateProfileString, addr szOptions, addr szKeyFlat, addr szNULL,\
                 addr szBuff2, 32, addr szAppPath
         mov     bl, byte ptr szBuff2
      .if eax == 1 && bl >= '0' && bl <= '1'
            sub     bl, 30h
            mov     FlatButtons, ebx
      .endif
      INVOKE     GetPrivateProfileString, addr szOptions, addr szKeyOnTop, addr szNULL,\
                 addr szBuff2, 32, addr szAppPath
         mov     bl, byte ptr szBuff2
      .if eax == 1 && bl >= '0' && bl <= '1'
            sub     bl, 30h
            mov     AlwaysOnTop, ebx
      .endif
      INVOKE     GetPrivateProfileString, addr szOptions, addr szKeyShow, addr szNULL,\
                 addr szBuff2, 32, addr szAppPath
         mov     bl, byte ptr szBuff2
      .if eax == 1 && bl >= '0' && bl <= '1'
            sub     bl, 30h
            mov     ShowToolTip, ebx
      .endif
      INVOKE     GetPrivateProfileString, addr szOptions, addr szKeyTop, addr szNULL,\
                 addr szBuff2, 32, addr szAppPath
         mov     bx, word ptr szBuff2
      .if eax == 1 && bl >= '0' && bl <= '9'
            sub     bl, 30h
            mov     TopPos, ebx
      .elseif eax == 2 && bl >= '0' && bl <= '9' && bh >= '0' && bh <= '9'
            sub     bl, 30h
            sub     bh, 30h
            xor     ecx, ecx
            mov     cl, bl
           imul     ecx, 10
            add     cl, bh
            mov     TopPos, ecx
      .endif
      INVOKE     GetPrivateProfileString, addr szOptions, addr szKeyRight, addr szNULL,\
                 addr szBuff2, 32, addr szAppPath
         mov     bx, word ptr szBuff2
      .if eax == 1 && bl >= '0' && bl <= '9'
            sub     bl, 30h
            mov     RightPos, ebx
      .elseif eax == 2 && bl >= '0' && bl <= '9' && bh >= '0' && bh <= '9'
            sub     bl, 30h
            sub     bh, 30h
            xor     ecx, ecx
            mov     cl, bl
           imul     ecx, 10
            add     cl, bh
            mov     RightPos, ecx
      .endif

         ret

GetOptions endp

;=======================================
; Update Toolbar procedure
;=======================================
UpdateTool PROC uses ebx esi edi
LOCAL    sfi:SHFILEINFO
LOCAL    tbb:TBBUTTON
LOCAL    BitmapOn:DWORD
LOCAL    szBuff2[2048]:BYTE, szBuff3[256]:BYTE, szBuff4[256]:BYTE

      INVOKE     ImageList_Create, 16, 15, ILC_COLOR32 or ILC_MASK, 24, 48
         mov     hImageList01, eax
      INVOKE     ImageList_AddIcon, hImageList01, hIcon
      INVOKE     SendMessage, hWndTool, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0
      INVOKE     SendMessage, hWndTool, TB_SETIMAGELIST, 0, hImageList01

         mov     szBuff2, 0
      INVOKE     GetPrivateProfileString, addr szToolbars, NULL, addr szNULL,\
                 addr szBuff2, 2048, addr szAppPath
      .if eax == 0
            jmp     EndIt
      .endif
         and     ToolCnt, 0
         xor     esi, esi
      .while (byte ptr szBuff2[esi] != 0)
         INVOKE     GetPrivateProfileString, addr szToolbars, addr szBuff2[esi], addr szNULL,\
                    addr szBuff3, 256, addr szAppPath
            lea     edx, szBuff3
            xor     edi, edi
           push     eax
         .while (eax)
            .if byte ptr[edx+edi] == ','
                  mov     byte ptr[edx+edi], 0
               .break
            .endif
               inc     edi
               dec     eax
         .endw
            pop     ebx
            and     BitmapOn, 0
         .if byte ptr szBuff3[ebx-1] == '1'        ; Use non program image
            INVOKE     GetPrivateProfileString, addr szImageInfo, addr szBuff2[esi], addr szNULL,\
                       addr szBuff4, 256, addr szAppPath
            .if byte ptr szBuff4[eax-3] == 'b' || byte ptr szBuff4[eax-3] == 'B'
                  mov     BitmapOn, 1
            .endif
         .endif
         .if byte ptr szBuff3[ebx-1] == '0' || byte ptr szBuff3[ebx-1] == '1' && !eax
               sub     ebx, edi
               sub     ebx, 2
            INVOKE     lstrcpyn, addr szBuff4, addr szBuff3[edi+1], ebx
         .endif
         .if !BitmapOn
            INVOKE     SHGetFileInfo, addr szBuff4, 0, addr sfi, sizeof SHFILEINFO,\
                       SHGFI_SYSICONINDEX or SHGFI_ICON or SHGFI_SMALLICON
            INVOKE     ImageList_AddIcon, hImageList01, sfi.hIcon
         .else
            INVOKE     LoadImage, NULL, addr szBuff4, IMAGE_BITMAP, 16, 16, LR_LOADFROMFILE
              push     eax
            INVOKE     ImageList_Add, hImageList01, eax, NULL
               pop     eax
            INVOKE     DeleteObject, eax
         .endif
            inc     ToolCnt
            add     esi, 9
      .endw

;---------- [Create the Toolbar structures] ----------
         mov     ebx, 1
         mov     edi, 2001
      .while (ToolCnt)
         TBButt     hWndTool, ebx, edi, 0
            inc     ebx
            inc     edi
            dec     ToolCnt
      .endw

EndIt:
      TBButt     hWndTool, 0, IDM_MENU, 0

         ret

UpdateTool endp

;=======================================
; Update menu procedure
;=======================================
UpdateMenu PROC uses ebx esi edi
LOCAL    szBuff2[2048]:BYTE, szBuff3[256]:BYTE

         mov     szBuff2, 0
      INVOKE     GetPrivateProfileString, addr szMenus, NULL, addr szNULL,\
                 addr szBuff2, 2048, addr szAppPath
      .if eax == 0
            jmp     EndIt
      .endif
         mov     ebx, 0
         mov     edi, 3001
         xor     esi, esi
      .while (byte ptr szBuff2[esi] != 0)
         INVOKE     GetPrivateProfileString, addr szMenus, addr szBuff2[esi], addr szNULL,\
                    addr szBuff3, 256, addr szAppPath
            lea     edx, szBuff3
            xor     ecx, ecx
         .while (eax)
            .if byte ptr[edx+ecx] == ','
                  mov     byte ptr[edx+ecx], 0
               .break
            .endif
               inc     ecx
               dec     eax
         .endw

         .if byte ptr szBuff3 != '0'
            INVOKE     InsertMenu, hSMenu, ebx, MF_BYPOSITION or MF_STRING, edi, addr szBuff3
         .else
            INVOKE     InsertMenu, hSMenu, ebx, MF_BYPOSITION or MF_SEPARATOR, edi, 0
         .endif
            inc     edi
            inc     ebx
            add     esi, 9
      .endw
      INVOKE     InsertMenu, hSMenu, ebx, MF_BYPOSITION or MF_SEPARATOR, edi, 0

EndIt:

         ret

UpdateMenu endp

;=======================================
; Tab Control PROCEDURE
;=======================================
TabCtlDlg PROC uses ebx hdlg:DWORD, wMsg, wParam, lParam

      .if wMsg == WM_INITDIALOG
;            mov     eax, hdlg
;            mov     hDlg, eax
         INVOKE     GetDlgItem, hdlg, 702               ; Get the handle of the Tab Control
            mov     hTab, eax                           ; Save it

;----------------- [Fill the Tab Control Item structure and insert the item] --------------------
            mov     tci.imask, TCIF_TEXT                ; Text
            mov     tci.lpReserved1, 0                  ; Reserved
            mov     tci.lpReserved2, 0                  ; Reserved
            mov     tci.pszText, offset TabTitle1       ; pointer to string containing tab text 
            mov     tci.cchTextMax, sizeof TabTitle1    ; Size of TabTitle
            mov     tci.iImage, -1                      ; Index to tab control's image 
            mov     tci.lParam, 0                       ; Extra info
         INVOKE     SendMessage, hTab, TCM_INSERTITEM, 0, offset tci

            mov     tci.pszText, offset TabTitle2
            mov     tci.cchTextMax, sizeof TabTitle2
         INVOKE     SendMessage, hTab, TCM_INSERTITEM, 1, addr tci

            mov     tci.pszText, offset TabTitle3
            mov     tci.cchTextMax, sizeof TabTitle3
         INVOKE     SendMessage, hTab, TCM_INSERTITEM, 2, addr tci

;----------------- [Load the dialog boxes in the Tab Controls] --------------------
         INVOKE     CreateDialogParam, hInst, 4801, hTab, offset MaintDlg, 4801 ;ToolbarDlg
            mov     hTabSeL1, eax

         INVOKE     CreateDialogParam, hInst, 4801, hTab, offset MaintDlg, 4802 ;MenuDlg
            mov     hTabSeL2, eax

         INVOKE     CreateDialogParam, hInst, 4803, hTab, offset MaintDlg, 4803 ;OptionDlg
            mov     hTabSeL3, eax

         INVOKE     SendMessage, hTab, TCM_SETCURSEL, TabSelect, 0
            mov     eax, TabSelect                      ; Previous selected Tab
            mov     ebx, hTabSeL1[eax*4]                ; Extract previous Tabs handle
         INVOKE     ShowWindow, ebx, SW_SHOWDEFAULT
         INVOKE     SetFocus, ebx
            jmp     GetOut

      .elseif wMsg == WM_NOTIFY
            mov     eax, lParam                         ; lParam is a pointer to a NMHDR Struct
            mov     eax, (NMHDR ptr [eax]).code         ; Check for TCN_SELCHANGE notify message
         .if eax == TCN_SELCHANGE
               mov     ebx, TabSelect                   ; Previous selected Tab
               mov     eax, hTabSeL1[ebx*4]             ; Extract previous Tabs handle
              push     eax
            INVOKE     SendMessage, hTab, TCM_GETCURSEL, 0, 0  ; New selected Tab
               mov     TabSelect, eax                   ; Save the Tab ID
               mov     ebx, hTabSeL1[eax*4]             ; Extract new Tabs handle
            INVOKE     ShowWindow, ebx, SW_SHOWDEFAULT  ; Show its window
               pop     eax
            INVOKE     ShowWindow, eax, SW_HIDE         ; Hide previous Tab window, prevents flicker if done after
            INVOKE     SetFocus, ebx
            .if TabSelect == 2
               INVOKE     GetDlgItem, hTabSeL3, 31
               INVOKE     SetFocus, eax
            .endif
         .endif

      .elseif wMsg == WM_CLOSE
            jmp     CancelOut

      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
           cwde
         .if eax == 401                                 ; Close
            .if UpdateOn || UpdateOn[4] || UpdateOn[8]
               INVOKE     MessageBox, NULL, addr szMsg03, addr AppName,
                          MB_YESNO or MB_ICONQUESTION or MB_SYSTEMMODAL
               .if eax == IDYES
                     jmp     GetOut
               .endif
            .endif

            .if ImageOn
                  and     ImageOn, 0
               INVOKE     WritePrivateProfileString, addr szImageInfo, addr szKeyName, NULL,\
                          addr szAppPath
            .endif
               jmp     CancelOut
         .endif
      .endif
         jmp     GetOut

CancelOut:
;INVOKE     keybd_event, VK_MENU, 0, 0, 0                 ; press Alt
;INVOKE     keybd_event, VK_ESCAPE, 0, 0, 0               ; press Space
;INVOKE     keybd_event, VK_ESCAPE, 0, KEYEVENTF_KEYUP, 0 ; release Escape
;INVOKE     keybd_event, VK_MENU, 0, KEYEVENTF_KEYUP, 0   ; release Alt
         xor     MenuOn, 1
      INVOKE     DeleteObject, hTempBU
      INVOKE     DeleteObject, hTempBD
      INVOKE     DestroyWindow, hList01
      INVOKE     DestroyWindow, hList02
      INVOKE     DestroyWindow, hTabSeL1
      INVOKE     DestroyWindow, hTabSeL2
      INVOKE     DestroyWindow, hTabSeL3
         and     hTempBU, 0
         and     hDlg, 0
      INVOKE     DestroyWindow, hdlg
         mov     eax, TRUE
         jmp     TabCtlRet

GetOut:
         mov     eax, FALSE

TabCtlRet:
         ret

TabCtlDlg ENDP

;=======================================
; Load the Listbox procedure
;=======================================
LoadListBox PROC uses ebx esi edi lpText:DWORD, nID
LOCAL    szBuff2[2048]:BYTE, szBuff3[256]:BYTE, szBuff4[256]:BYTE

            mov     edi, nID
            mov     szBuff2, 0
         INVOKE     GetPrivateProfileString, lpText, NULL, addr szNULL,\
                    addr szBuff2, 2048, addr szAppPath
         .if eax == 0
               ret
         .endif
            xor     esi, esi
         .while (byte ptr szBuff2[esi] != 0)
            INVOKE     GetPrivateProfileString, lpText, addr szBuff2[esi], addr szNULL,\
                       addr szBuff3, 256, addr szAppPath
              push     eax
            INVOKE     lstrcpy, addr szBuff4, addr szBuff2[esi]
            INVOKE     lstrcat, addr szBuff4, addr szEqu
            INVOKE     lstrcat, addr szBuff4, addr szBuff3
            INVOKE     SendMessage, hListH, LB_ADDSTRING, 0, addr szBuff4
               pop     eax
               lea     edx, szBuff3
               xor     ecx, ecx
            .while (eax)
               .if byte ptr [edx+ecx] == ','
                     mov     byte ptr[edx+ecx], 0
                  .break
               .endif
                  inc     ecx
                  dec     eax
            .endw
            INVOKE     lstrcpy, addr szBuff4, addr szBuff3[ecx+1]
            .if byte ptr szBuff3 != '0'
               INVOKE     SendMessage, hList, LB_ADDSTRING, 0, addr szBuff3
            .else
               INVOKE     SendMessage, hList, LB_ADDSTRING, 0, addr szSep
            .endif
              push     eax
            INVOKE     SendMessage, hList, LB_SETITEMDATA, eax, edi
               pop     eax
            INVOKE     SendMessage, hListH, LB_SETITEMDATA, eax, edi
               inc     edi
               add     esi, 9
;INVOKE     MessageBox, NULL, addr szBuff3, addr AppName, MB_OK
;INVOKE     MessageBox, NULL, addr szBuff4, addr AppName, MB_OK
         .endw
         INVOKE     SendMessage, hList, LB_SETCURSEL, 0, 0

         ret

LoadListBox ENDP

;=======================================
; Up Down procedure
;=======================================
UpDown PROC uses ebx esi ID:DWORD
LOCAL    szBuff1[256]:BYTE, szBuff2[256]:BYTE

         INVOKE     SendMessage, hList, LB_GETCURSEL, 0, 0
         .if eax == LB_ERR
               ret
         .endif
            mov     esi, eax
         INVOKE     SendMessage, hList, LB_GETCOUNT, 0, 0
            dec     eax
            mov     ecx, eax
         .if ID == 301 && esi < 1 || ID == 302 && esi >= ecx
               ret
         .endif
         INVOKE     SendMessage, hList, LB_GETTEXT, esi, addr szBuff1
         INVOKE     SendMessage, hListH, LB_GETTEXT, esi, addr szBuff2
         INVOKE     SendMessage, hList, LB_GETITEMDATA, esi, 0
            mov     ebx, eax
         INVOKE     SendMessage, hListH, LB_DELETESTRING, esi, 0
         INVOKE     SendMessage, hList, LB_DELETESTRING, esi, 0
         .if ID == 301
               dec     esi
         .else
               inc     esi
         .endif
         INVOKE     SendMessage, hList, LB_INSERTSTRING, esi, addr szBuff1
         INVOKE     SendMessage, hListH, LB_INSERTSTRING, esi, addr szBuff2
         INVOKE     SendMessage, hList, LB_SETITEMDATA, esi, ebx
         INVOKE     SendMessage, hListH, LB_SETITEMDATA, esi, ebx
         INVOKE     SendMessage, hList, LB_SETCURSEL, esi, 0

         ret

UpDown ENDP

;=======================================
; Update the AppLoad.ini procedure
;=======================================
UpdateINI PROC uses ebx esi edi lpText:DWORD
LOCAL    rect:RECT
LOCAL    szBuff1[32]:BYTE, szBuff2[2048]:BYTE, szBuff3[256]:BYTE, szBuff4[256]:BYTE
LOCAL    szBuff5[256]:BYTE, szKey[32]:BYTE

         mov     szBuff2, 0
         mov     eax, lpText
      .if byte ptr[eax] == 'T' || byte ptr[eax] == 'M'
         INVOKE     GetPrivateProfileString, lpText, NULL, addr szNULL,\
                    addr szBuff2, 2048, addr szAppPath
         .if eax == 0
               jmp     NoDelete
         .endif
            xor     esi, esi
         .while (byte ptr szBuff2[esi] != 0)
            INVOKE     WritePrivateProfileString, lpText, addr szBuff2[esi], NULL, addr szAppPath
               add     esi, 9
         .endw

NoDelete:
            mov     eax, lpText
         .if byte ptr[eax] == 'T'                ; Toolbar dialog
            INVOKE     lstrcpy, addr szKey, addr szKeyTool
               mov     edi, 2001
   
         .elseif byte ptr[eax] == 'M'            ; Menu dialog
            INVOKE     lstrcpy, addr szKey, addr szKeyMenu
               mov     edi, 3001
         .endif
         INVOKE     SendMessage, hListH, LB_GETCOUNT, 0, 0
            mov     ebx, eax
            xor     esi, esi
         .while (ebx)
            INVOKE     SendMessage, hListH, LB_GETTEXT, esi, addr szBuff3
              push     eax
            INVOKE     wsprintf, addr szBuff2, addr fmat1, edi
            INVOKE     lstrcpy, addr szBuff4, addr szKey
            INVOKE     lstrcat, addr szBuff4, addr szBuff2
            INVOKE     WritePrivateProfileString, lpText, addr szBuff4, addr szBuff3+9, addr szAppPath

            INVOKE     SendMessage, hListH, LB_GETITEMDATA, esi, 0
            INVOKE     wsprintf, addr szBuff2, addr fmat1, eax
            INVOKE     lstrcpy, addr szBuff1, addr szKey
            INVOKE     lstrcat, addr szBuff1, addr szBuff2
            INVOKE     GetPrivateProfileString, addr szImageInfo, addr szBuff1, addr szNULL,\
                       addr szBuff5, 256, addr szAppPath
               pop     ecx
            .if eax && byte ptr szBuff3[ecx-1] == '1'
;INVOKE     MessageBox, NULL, addr szBuff1, addr AppName, MB_OK
;INVOKE     MessageBox, NULL, addr szBuff4, addr AppName, MB_OK
               INVOKE     WritePrivateProfileString, addr szImageInfo, addr szBuff1, NULL, addr szAppPath
               INVOKE     WritePrivateProfileString, addr szImageInfo, addr szBuff4, addr szBuff5, addr szAppPath
            .endif
            INVOKE     SendMessage, hListH, LB_GETITEMDATA, esi, 0
            .if eax == ImageOn
               INVOKE     WritePrivateProfileString, addr szImageInfo, addr szBuff4, addr szImageFile,\
                          addr szAppPath
            .endif

               inc     esi
               inc     edi
               dec     ebx
         .endw

            mov     szBuff2, 0
         INVOKE     GetPrivateProfileString, addr szImageInfo, NULL, addr szNULL,\
                    addr szBuff2, 2048, addr szAppPath
         .if eax
               xor     esi, esi
            .while (byte ptr szBuff2[esi] != 0)
               INVOKE     GetPrivateProfileString, addr szToolbars, addr szBuff2[esi], addr szNULL,\
                          addr szBuff3, 256, addr szAppPath
               .if byte ptr szBuff3[eax-1] == '0'
                  INVOKE     WritePrivateProfileString, addr szImageInfo, addr szBuff2[esi], NULL, addr szAppPath
               .endif
                  add     esi, 9
            .endw
         .endif

      .elseif byte ptr[eax] == 'O'               ; Options dialog
         INVOKE     wsprintf, addr szBuff2, addr fmat1, FlatButtons
         INVOKE     WritePrivateProfileString, lpText, addr szKeyFlat, addr szBuff2, addr szAppPath
         INVOKE     wsprintf, addr szBuff2, addr fmat1, AlwaysOnTop
         INVOKE     WritePrivateProfileString, lpText, addr szKeyOnTop, addr szBuff2, addr szAppPath
         INVOKE     wsprintf, addr szBuff2, addr fmat1, ShowToolTip
         INVOKE     WritePrivateProfileString, lpText, addr szKeyShow, addr szBuff2, addr szAppPath
         INVOKE     wsprintf, addr szBuff2, addr fmat1, TopPos
         INVOKE     WritePrivateProfileString, lpText, addr szKeyTop, addr szBuff2, addr szAppPath
         INVOKE     wsprintf, addr szBuff2, addr fmat1, RightPos
         INVOKE     WritePrivateProfileString, lpText, addr szKeyRight, addr szBuff2, addr szAppPath
            mov     ecx, dwStyle
         .if FlatButtons
                or     ecx, TBSTYLE_FLAT
                or     ecx, TBSTYLE_TRANSPARENT
         .endif
         .if ShowToolTip
                or     ecx, TBSTYLE_TOOLTIPS
         .endif
            INVOKE     SetWindowLong, hWndTool, GWL_STYLE, ecx
            INVOKE     RedrawWindow, hWndTool, 0, 0,\
                       RDW_ERASE or RDW_INVALIDATE or RDW_UPDATENOW

;         .if ChangeOn == 1 || ChangeOn == 3
              call     SizeIt
;         .endif
      .endif

         mov     eax, lpText
      .if byte ptr[eax] == 'T'
         INVOKE     SendMessage, hWndTool, TB_BUTTONCOUNT, 0, 0
            mov     ebx, eax
         .while (ebx)
            INVOKE     SendMessage, hWndTool, TB_DELETEBUTTON, 0, 0
               dec     ebx
         .endw
         INVOKE     ImageList_Destroy, hImageList01
           call     UpdateTool
           call     SizeIt

      .elseif byte ptr[eax] == 'M'
         INVOKE     GetMenuItemCount, hSMenu
         .if eax > 3
               sub     eax, 4
               mov     ebx, eax
            .while (ebx)
               INVOKE     DeleteMenu, hSMenu, 0, MF_BYPOSITION
                  dec     ebx
            .endw
              call     UpdateMenu
         .endif

      .elseif byte ptr[eax] == 'O'

      .endif
         and     ImageOn, 0

         ret

SizeIt:
      INVOKE     GetClientRect, hWnd, addr rect
         mov     ebx, rect.right
         mov     ecx, rect.bottom
         shl     ecx, 16
         mov     cx, bx
      INVOKE     SendMessage, hWnd, WM_SIZE, SIZE_RESTORED, ecx
        retn

UpdateINI ENDP

;=======================================
; Add or Edit Dialog
;=======================================
AddEditDlg PROC uses ebx esi edi hdlg:DWORD, wMsg, wParam, lParam
LOCAL    ofn:OPENFILENAME
LOCAL    szBuff1[256]:BYTE, szBuff2[256]:BYTE, szBuff3[256]:BYTE, szFilter[256]:BYTE

      .if wMsg == WM_INITDIALOG
            and     ImageOn, 0
         INVOKE     GetDlgItem, hdlg, 301        ; Get the handle of the Combobox
            mov     hComboBox01, eax             ; Save it
         INVOKE     SendMessage, hComboBox01, CB_SETITEMHEIGHT, -1, 14  ; Edit field
         INVOKE     SendMessage, hComboBox01, CB_SETITEMHEIGHT, 0, 14   ; List items
         INVOKE     SendMessage, hComboBox01, CB_ADDSTRING, 0, addr szUse
         INVOKE     SendMessage, hComboBox01, CB_SETCURSEL, 0, 0
         .if lParam == 402                       ; Add from MaintDlg
            INVOKE     SendMessage, hList, LB_GETCOUNT, 0, 0
               inc     eax
               mov     ebx, eax
            INVOKE     SendMessage, hList, LB_GETCURSEL, 0, 0
            .if eax == LB_ERR && ebx > 1
                  ret
            .endif
               inc     eax
            .if eax == LB_ERR
                  mov     eax, 0
            .endif
               mov     CurSelect, eax
               mov     eax, hList
            .if eax == hListBox01
               INVOKE     lstrcpy, addr szKeyName, addr szKeyTool
                  add     ebx, 2000
            .else
               INVOKE     lstrcpy, addr szKeyName, addr szKeyMenu
                  add     ebx, 3000
            .endif
               mov     AddOn, ebx
            INVOKE     wsprintf, addr szBuff1, addr fmat1, ebx
            INVOKE     lstrcat, addr szKeyName, addr szBuff1

         .elseif lParam == 403                   ; Edit from MaintDlg
               and     AddOn, 0
               mov     eax, hList
            .if eax == hListBox02
               INVOKE     GetDlgItem, hdlg, 405
               INVOKE     EnableWindow, eax, FALSE
            .endif
            INVOKE     SendMessage, hdlg, WM_SETTEXT, 0, addr szEdit
            INVOKE     SendMessage, hList, LB_GETCURSEL, 0, 0
            .if eax == LB_ERR
                  ret
            .endif
               mov     CurSelect, eax
            INVOKE     SendMessage, hListH, LB_GETTEXT, CurSelect, addr szBuff1
               lea     edx, szBuff1
               xor     ecx, ecx
              push     eax
            .while (eax)
               .if byte ptr [edx+ecx] == ','
                     mov     byte ptr[edx+ecx], 0
                  .break
               .endif
                  inc     ecx
                  dec     eax
            .endw
               pop     eax
               sub     eax, ecx
               sub     eax, 2
            INVOKE     lstrcpyn, addr szBuff2, addr szBuff1[ecx+1], eax
            INVOKE     lstrcpyn, addr szKeyName, addr szBuff1, 9
            .if byte ptr szBuff1+9 != '0'
               INVOKE     SendDlgItemMessage, hdlg, 201, WM_SETTEXT, 0, addr szBuff1+9
               INVOKE     SendDlgItemMessage, hdlg, 202, WM_SETTEXT, 0, addr szBuff2
            .else
               INVOKE     SendDlgItemMessage, hdlg, 201, WM_SETTEXT, 0, addr szSep
            .endif
            INVOKE     GetPrivateProfileString, addr szImageInfo, addr szKeyName, addr szNULL,\
                       addr szBuff1, 256, addr szAppPath
            .if eax
               INVOKE     SendMessage, hComboBox01, CB_ADDSTRING, 0, addr szBuff1
               INVOKE     SendMessage, hComboBox01, CB_SETCURSEL, eax, 0
            .endif
         .endif

      .elseif wMsg == WM_CLOSE
            jmp     CancelOut

      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
           cwde
         .if eax == 401                          ; Browse for program path
               mov     byte ptr szBuff2, 2ah
               mov     dword ptr szBuff2+1, 'exe.'
               mov     byte ptr szBuff2+5, 0
               mov     ecx, lengthof szExec
               mov     esi, offset szExec
               lea     edi, szFilter
               rep     movsb
               mov     szBuff3, 0
              call     OpenFileDlg
            .if !eax                             ; Cancel'ed or error occurred
                  jmp     AddEditTDone
            .endif
            INVOKE     SendDlgItemMessage, hdlg, 202, WM_SETTEXT, 0, addr szBuff2

         .elseif eax == 402                      ; Browse for Image
               mov     szBuff2, 0
               mov     ecx, lengthof szImage
               mov     esi, offset szImage
               lea     edi, szFilter
               rep     movsb
            INVOKE     lstrcpy, addr szBuff3, addr RootDir
              call     OpenFileDlg
            .if !eax                             ; Cancel'ed or error occurred
                  jmp     AddEditTDone
            .endif

            INVOKE     SendMessage, hComboBox01, CB_ADDSTRING, 0, addr szBuff2
            INVOKE     SendMessage, hComboBox01, CB_SETCURSEL, eax, 0

         .elseif eax == 403                      ; Cancel
               jmp     CancelOut


         .elseif eax == 404                      ; Update
               mov     eax, TabSelect
               mov     UpdateOn[eax*4], 1
            INVOKE     EnableWindow, hUpdate[eax*4], TRUE
            INVOKE     SendMessage, hComboBox01, CB_GETCURSEL, 0, 0
            .if eax != CB_ERR && eax
                  mov     ecx, eax
               INVOKE     SendMessage, hComboBox01, CB_GETLBTEXT, ecx, addr szImageFile
               .if word ptr szImageFile+1 == '\:'
                     mov     ImageOn, 1
               .endif
            .endif

            INVOKE     GetDlgItemText, hdlg, 201, addr szBuff1, sizeof szBuff1
            INVOKE     GetDlgItemText, hdlg, 202, addr szBuff2, sizeof szBuff2
            INVOKE     lstrcpy, addr szBuff3, addr szKeyName
            INVOKE     lstrcat, addr szBuff3, addr szEqu
            .if byte ptr szBuff1 != '-'
               .if !szBuff1 || !szBuff2
                  INVOKE     MessageBox, NULL, addr szMsg02, addr AppName,
                             MB_OK or MB_ICONEXCLAMATION or MB_SYSTEMMODAL
                     jmp     AddEditTDone
               .endif
               INVOKE     lstrcat, addr szBuff3, addr szBuff1
               INVOKE     lstrcat, addr szBuff3, addr szComma
               INVOKE     lstrcat, addr szBuff3, addr szBuff2
            .else
               INVOKE     lstrcat, addr szBuff3, addr szZero
            .endif

            .if !AddOn
               INVOKE     SendMessage, hListBox01, LB_GETITEMDATA, CurSelect, 0
                  mov     ebx, eax
               INVOKE     SendMessage, hList, LB_DELETESTRING, CurSelect, 0
               INVOKE     SendMessage, hListH, LB_DELETESTRING, CurSelect, 0
            .else
                  mov     ebx, AddOn
            .endif
            .if ImageOn
                  mov     ImageOn, ebx
               INVOKE     WritePrivateProfileString, addr szImageInfo, addr szKeyName, addr szImageFile,\
                          addr szAppPath
               INVOKE     lstrcat, addr szBuff3, addr szImage1
            .else
               INVOKE     lstrcat, addr szBuff3, addr szImage0
            .endif

            INVOKE     SendMessage, hList, LB_INSERTSTRING, CurSelect, addr szBuff1
            INVOKE     SendMessage, hListH, LB_INSERTSTRING, CurSelect, addr szBuff3
            INVOKE     SendMessage, hList, LB_SETITEMDATA, CurSelect, ebx
            INVOKE     SendMessage, hListH, LB_SETITEMDATA, CurSelect, ebx
            INVOKE     SendMessage, hList, LB_SETCURSEL, CurSelect, 0
               jmp     CancelOut

         .elseif eax == 405                      ; Seperator
            INVOKE     SendDlgItemMessage, hdlg, 201, WM_SETTEXT, 0, addr szSep
         .endif

      .endif
         jmp     AddEditTDone

CancelOut:
      INVOKE     EndDialog, hdlg, wParam
         mov     eax, TRUE
         jmp     AddEditTRet

AddEditTDone:
         mov     eax, FALSE

AddEditTRet:
         ret

OpenFileDlg:
      INVOKE     RtlZeroMemory, addr ofn, sizeof ofn
         mov     ofn.lStructSize, sizeof ofn
         mov     eax, hTab
         mov     ofn.hwndOwner, eax
         mov     eax, hInst
         mov     ofn.hInstance, eax
         lea     eax, szFilter
         mov     ofn.lpstrFilter, eax
         lea     eax, szBuff2
         mov     ofn.lpstrFile, eax
         mov     ofn.nMaxFile, lengthof szBuff2
         mov     ofn.lpstrTitle, offset szOpenTitle
         lea     eax, szBuff3
         mov     ofn.lpstrInitialDir, eax
         mov     ofn.Flags, OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST
      INVOKE     GetOpenFileName, addr ofn
        retn

AddEditDlg ENDP

;=======================================
; Toolbar and Menu maintenance Dialog
;=======================================
MaintDlg PROC uses ebx esi edi hdlg:DWORD, wMsg, wParam, lParam
LOCAL    sfi:SHFILEINFO
LOCAL    rect:RECT
LOCAL    rect2:RECT
LOCAL    hTemp:DWORD, hBrush, Len, hBitmap, hbmpMem, hbmpOld, hFontOld, hMemDC, hDMemDC, TextColor
LOCAL    szBuff1[256]:BYTE, szBuff2[256]:BYTE, szBuff3[32]:BYTE, szBuff4[256]:BYTE

      .if wMsg == WM_INITDIALOG
            mov     ebx, lParam
            sub     ebx, 4801
         INVOKE     GetDlgItem, hdlg, 405        ; Get the handle of the Update button
            mov     hUpdate[ebx*4], eax
            mov     UpdateOn[ebx*4], 0
         INVOKE     EnableWindow, hUpdate[ebx*4], FALSE
         INVOKE     SetWindowLong, hUpdate[ebx*4], GWL_WNDPROC, offset ButtonProc
            mov     SubButtbox, eax

         INVOKE     GetDlgItem, hdlg, 201        ; Get the handle of the Listbox
            mov     ebx, eax                     ; Save it

         .if !hTempBU
            INVOKE     LoadBitmap, 0, OBM_UPARROW
               mov     hTempBU, eax
            INVOKE     LoadBitmap, 0, OBM_DNARROW
               mov     hTempBD, eax
         .endif
         INVOKE     GetDlgItem, hdlg, 301
            mov     hTemp, eax
         INVOKE     SendMessage, hTemp, BM_SETIMAGE, IMAGE_BITMAP, hTempBU
         INVOKE     GetDlgItem, hdlg, 302
            mov     hTemp, eax
         INVOKE     SendMessage, hTemp, BM_SETIMAGE, IMAGE_BITMAP, hTempBD
         INVOKE     SendMessage, ebx, WM_SETFONT, hFontL, TRUE
         INVOKE     SendMessage, ebx, LB_SETITEMHEIGHT, 0, 17        ; List items

         .if lParam == 4801 || lParam == 4802
            INVOKE     SetWindowLong, ebx, GWL_WNDPROC, offset ListboxProc
               mov     SubListbox, eax
            INVOKE     GetWindowRect, ebx, addr rect
               mov     eax, rect.top
               sub     rect.bottom, eax
               mov     eax, rect.left
               sub     rect.right, eax
               xor     edx, edx
               mov     eax, rect.bottom
               mov     ecx, 17
               div     ecx
               mov     ListNum, eax
              imul     eax, 17
               mov     NextLast, eax
               sub     NextLast, 34
               add     eax, 4            ; Adjust for EXstyle

               mov     rect.bottom, eax
            INVOKE     MoveWindow, ebx, 0, 7, rect.right, rect.bottom, TRUE

; WS_VISIBLE or
;---------- [Create a hidden work Listbox] ----------
            INVOKE     CreateWindowEx, NULL, addr ListboxClass, NULL,\
                       WS_CHILD or WS_VSCROLL or LBS_HASSTRINGS,\
                       0, 0, 400, 400, hdlg, 82, hInst, NULL
            .if lParam == 4801
                  mov     hList01, eax
                  mov     hListH, eax
                  mov     hListBox01, ebx
                  mov     hList, ebx
               INVOKE     LoadListBox, addr szToolbars, 2001
            .elseif lParam == 4802
                  mov     hList02, eax
                  mov     hListH, eax
                  mov     hListBox02, ebx
                  mov     hList, ebx
               INVOKE     LoadListBox, addr szMenus, 3001
            .endif

         .elseif lParam == 4803
            INVOKE     SendDlgItemMessage, hdlg, 311, BM_SETCHECK, FlatButtons, 0
            INVOKE     SendDlgItemMessage, hdlg, 312, BM_SETCHECK, AlwaysOnTop, 0
            INVOKE     SendDlgItemMessage, hdlg, 313, BM_SETCHECK, ShowToolTip, 0
            INVOKE     SetDlgItemInt, hdlg, 501, TopPos, FALSE
            INVOKE     SetDlgItemInt, hdlg, 502, RightPos, FALSE
         .endif

      .elseif wMsg == WM_DRAWITEM
         .if wParam == 201 || wParam == 405
               mov     esi, lParam
               lea     edi, dis
               mov     ecx, sizeof dis
               rep     movsb
            .if dis.itemID != -1
               .if wParam == 405
                     jmp     DoButt
               .endif

               INVOKE     CopyRect, addr rect2, addr dis.rcItem
               INVOKE     CreateCompatibleDC, dis.hdc
                  mov     hMemDC, eax
                  mov     eax, rect2.left
                  sub     rect2.right, eax
                  mov     eax, rect2.top
                  sub     rect2.bottom, eax
                  mov     rect2.left, 0
                  mov     rect2.top, 0
               INVOKE     CreateCompatibleBitmap, dis.hdc, rect2.right, rect2.bottom
                  mov     hbmpMem, eax
               INVOKE     SelectObject, hMemDC, hbmpMem
                  mov     hbmpOld, eax
               INVOKE     SelectObject, hMemDC, hFontL
                  mov     hFontOld, eax
               INVOKE     SetBkMode, hMemDC, TRANSPARENT

               .if TabSelect == 0
                    push     hListBox01
                     mov     edi, hList01
               .else
                    push     hListBox02
                     mov     edi, hList02
               .endif
                  pop     hList
               INVOKE     SendMessage, hList, LB_GETTEXT, dis.itemID, addr szBuff1
                  mov     Len, eax
               INVOKE     SendMessage, edi, LB_GETTEXT, dis.itemID, addr szBuff2
                  mov     szBuff4, 0
                  and     hBitmap, 0
               .if byte ptr szBuff2[eax-1] == '1'
         INVOKE     SendMessage, edi, LB_GETITEMDATA, dis.itemID, 0
                  INVOKE     wsprintf, addr szBuff4, addr fmat1, eax
                  INVOKE     lstrcpy, addr szBuff3, addr szKeyTool
                  INVOKE     lstrcat, addr szBuff3, addr szBuff4
                  INVOKE     GetPrivateProfileString, addr szImageInfo, addr szBuff3, addr szNULL,\
                             addr szBuff2, 256, addr szAppPath
                  .if byte ptr szBuff2[eax-3] == 'b' || byte ptr szBuff2[eax-3] == 'B'
                     INVOKE     LoadImage, NULL, addr szBuff2, IMAGE_BITMAP, 16, 16, LR_LOADFROMFILE
                        mov     hBitmap, eax
                  .endif
               .else
                     mov     ecx, Len
                     add     ecx, 10
                     sub     eax, ecx
                     dec     eax
                  INVOKE     lstrcpyn, addr szBuff2, addr szBuff2[ecx], eax
               .endif

               .if (dis.itemState & ODS_SELECTED)
                  INVOKE     CreateSolidBrush, 00005900h       ; Highlight background color
                     mov     hBrush, eax
;add     dis.rcItem.left, 17
                  INVOKE     FillRect, hMemDC, addr rect2, eax
;sub     dis.rcItem.left, 17
                  INVOKE     SetTextColor, hMemDC, 00ffffffh   ; Highlight text color
                  INVOKE     SetBkColor, hMemDC, 0005900h     ; Highlight text background color
               .else
                  INVOKE     CreateSolidBrush, 00ffffffh       ; Background color
                     mov     hBrush, eax
                  INVOKE     FillRect, hMemDC, addr rect2, eax
                  INVOKE     SetTextColor, hMemDC, 00ff0000h   ; Text color - dis.itemData
                  INVOKE     SetBkColor, hMemDC, 00ffffffh     ; Text background color
               .endif
                  add     rect2.left, 20
                  add     rect2.top, 2
               INVOKE     TextOut, hMemDC, rect2.left, rect2.top, addr szBuff1, Len
                  sub     rect2.top, 2
                  sub     rect2.left, 19
                  mov     rect2.right, 17
               INVOKE     DeleteObject, hBrush
               .if byte ptr szBuff1 != '-'
                  .if !hBitmap
                     INVOKE     SHGetFileInfo, addr szBuff2, 0, addr sfi, sizeof SHFILEINFO,\
                                SHGFI_SYSICONINDEX or SHGFI_SMALLICON
                        mov     ecx, eax
                     INVOKE     ImageList_Draw, ecx, sfi.iIcon, hMemDC, 1, rect2.top,\
                                ILD_NORMAL or ILD_TRANSPARENT
                  .else
                     INVOKE     CreateCompatibleDC, hMemDC     ; Create a compatible dc in memory
                        mov     hDMemDC, eax
                     INVOKE     SelectObject, hDMemDC, hBitmap ; Select the opened bitmap into the dc
                     INVOKE     BitBlt, hMemDC, 1, rect2.top, 16, 16, hDMemDC, 0, 0, SRCCOPY ;Copy the bitmap
                     INVOKE     DeleteDC, hDMemDC              ; Delete the memory dc
                     INVOKE     DeleteObject, hBitmap
                  .endif
               .endif
                  mov     ecx, dis.rcItem.right
                  sub     ecx, dis.rcItem.left
                  mov     edx, dis.rcItem.bottom
                  sub     edx, dis.rcItem.top
               INVOKE     BitBlt, dis.hdc, dis.rcItem.left, dis.rcItem.top, ecx, edx, hMemDC, 0, 0, SRCCOPY
               INVOKE     SelectObject, hMemDC, hbmpOld
               INVOKE     DeleteObject, hbmpMem
               INVOKE     SelectObject, hMemDC, hFontOld
               INVOKE     DeleteDC, hMemDC

;               INVOKE     SendMessage, hList, LB_GETCOUNT, 0, 0
;                  dec     eax
;                  mov     ecx, NextLast
;               .if eax == dis.itemID && dis.rcItem.top == ecx
;                  INVOKE     CreateSolidBrush, 00ffffffh       ; Background color
;                     mov     hBrush, eax
;                     add     dis.rcItem.top, 17
;                     add     dis.rcItem.bottom, 17
;                  INVOKE     FillRect, dis.hdc, addr dis.rcItem, eax
;                  INVOKE     DeleteObject, hBrush
;               .endif
               INVOKE     SendMessage, hList, LB_GETCOUNT, 0, 0
               .if eax < ListNum
                    imul     eax, 17
                     mov     dis.rcItem.top, eax
                     mov     eax, ListNum
                    imul     eax, 17
                     mov     dis.rcItem.bottom, eax
                  INVOKE     CreateSolidBrush, 00ffffffh       ; Background color
                     mov     hBrush, eax
                  INVOKE     FillRect, dis.hdc, addr dis.rcItem, eax
                  INVOKE     DeleteObject, hBrush
               .endif
            .endif
               mov     dis.itemState, ODS_DEFAULT
               mov     dis.hdc, 0

         .endif
            mov     eax, 1
            ret

DoButt:
            mov     ecx, TabSelect
         INVOKE     IsWindowEnabled, hUpdate[ecx*4]
         .if eax
               mov     TextColor, 00008000h
         .else
               mov     TextColor, 000000ffh
         .endif
         .if (dis.itemState & ODS_SELECTED)
               mov     TextColor, 0
         .endif
         INVOKE     GetSysColor, COLOR_BTNFACE
         INVOKE     CreateSolidBrush, eax
            mov     hBrush, eax

         INVOKE     FillRect, dis.hdc, addr dis.rcItem, hBrush
         INVOKE     SetTextColor, dis.hdc, TextColor
         INVOKE     SetBkMode, dis.hdc, TRANSPARENT
         .if (dis.itemState & ODS_SELECTED)
            INVOKE     DrawEdge, dis.hdc, addr dis.rcItem, EDGE_SUNKEN, BF_RECT
               add     dis.rcItem.left, 2
               add     dis.rcItem.top, 2
         .else
            .if TextColor == 0ffh
                  mov     ecx, EDGE_ETCHED
            .else
                  mov     ecx, EDGE_RAISED
            .endif
            INVOKE     DrawEdge, dis.hdc, addr dis.rcItem, ecx, BF_RECT
         .endif
         INVOKE     DrawText, dis.hdc, addr szButText, -1, addr dis.rcItem,\
                    DT_CENTER or DT_VCENTER or DT_SINGLELINE
.if (dis.itemState & ODS_FOCUS)
INVOKE     SetTextColor, dis.hdc, 0
add     dis.rcItem.left, 3
add     dis.rcItem.top, 3
sub     dis.rcItem.right, 3
sub     dis.rcItem.bottom, 3
INVOKE     DrawFocusRect, dis.hdc, addr dis.rcItem
.endif
         INVOKE     DeleteObject, hBrush
            mov     dis.itemState, ODS_DEFAULT
            mov     dis.hdc, 0

      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
           cwde

            mov     ecx, wParam
            shr     ecx, 16

         .if ecx == BN_CLICKED
            INVOKE     GetFocus
            INVOKE     GetDlgCtrlID, eax
            .if eax >= 311 && eax <= 313 && eax != wParam  ; If eax = wParam it was LButt click
                  mov     wParam, eax
               INVOKE     GetDlgItem, hdlg, eax
                  mov     lParam, eax
               INVOKE     SendDlgItemMessage, hdlg, wParam, BM_GETCHECK, 0, 0
                  xor     ecx, ecx
               .if !eax
                     mov     ecx, 1
               .endif
               INVOKE     SendDlgItemMessage, hdlg, wParam, BM_SETCHECK, ecx, 0
                  mov     eax, wParam
            .endif
         .endif

         .if TabSelect == 0
               mov     esi, hListBox01
               mov     hList, esi
               mov     edi, hList01
               mov     hListH, edi
               mov     ebx, 4901
         .elseif TabSelect == 1
               mov     esi, hListBox02
               mov     hList, esi
               mov     edi, hList02
               mov     hListH, edi
               mov     ebx, 4902
         .elseif TabSelect == 2

         .else
               jmp     MaintDone
         .endif

;---------- [Up Down buttons] ----------
         .if eax == 301 || eax == 302
            INVOKE     UpDown, eax
               mov     eax, TabSelect
               mov     UpdateOn[eax*4], 1
            INVOKE     EnableWindow, hUpdate[eax*4], TRUE

         .elseif eax >= 311 && eax <= 313 || eax == 501 && TabSelect == 2 && hDlg ||\
                 eax == 502 && TabSelect == 2 && hDlg
               mov     ebx, eax
               mov     ecx, TopPos
               mov     eax, RightPos
            .if ebx == 501 || ebx == 502
               INVOKE     GetDlgItemInt, hdlg, 501, NULL, FALSE
                 push     eax
               INVOKE     GetDlgItemInt, hdlg, 502, NULL, FALSE
                  pop     ecx
            .endif

            .if ecx != TopPos || eax != RightPos || ebx >= 311 && ebx <= 313
                  mov     eax, TabSelect
                  mov     UpdateOn[eax*4], 1
               INVOKE     EnableWindow, hUpdate[eax*4], TRUE
            .endif

         .elseif eax == 402 || eax == 403        ; Add or Edit
            INVOKE     DialogBoxParam, hInst, ebx, hTab, offset AddEditDlg, eax

         .elseif eax == 404                      ; Remove
            INVOKE     MessageBox, NULL, addr szMsg01, addr AppName,
                       MB_YESNO or MB_ICONQUESTION or MB_SYSTEMMODAL
            .if eax == IDNO
                  jmp     MaintDone
            .endif
               mov     eax, TabSelect
               mov     UpdateOn[eax*4], 1
            INVOKE     EnableWindow, hUpdate[eax*4], TRUE
            INVOKE     SendMessage, esi, LB_GETCURSEL, 0, 0
               mov     ebx, eax
            INVOKE     SendMessage, edi, LB_DELETESTRING, ebx, 0
            INVOKE     SendMessage, esi, LB_DELETESTRING, ebx, 0
            INVOKE     SendMessage, esi, WM_VSCROLL, SB_LINEUP, 0

         .elseif eax == 405                      ; Update
               mov     eax, TabSelect
               mov     UpdateOn[eax*4], 0
            INVOKE     EnableWindow, hUpdate[eax*4], FALSE

            .if TabSelect == 0
               INVOKE     UpdateINI, addr szToolbars

            .elseif TabSelect == 1
               INVOKE     UpdateINI, addr szMenus

            .elseif TabSelect == 2
                  and     ChangeOn, 0
                 push     FlatButtons
               INVOKE     SendDlgItemMessage, hdlg, 311, BM_GETCHECK, 0, 0
                  mov     FlatButtons, eax
               INVOKE     SendDlgItemMessage, hdlg, 312, BM_GETCHECK, 0, 0
                  mov     AlwaysOnTop, eax
               INVOKE     SendDlgItemMessage, hdlg, 313, BM_GETCHECK, 0, 0
                  mov     ShowToolTip, eax
                 push     TopPos
               INVOKE     GetDlgItemInt, hdlg, 501, NULL, FALSE
               .if eax >= 0 && eax <= 99
                     mov     TopPos, eax
               .endif
                  pop     eax
               .if TopPos != eax
                     add     ChangeOn, 1
               .endif
                 push     RightPos
               INVOKE     GetDlgItemInt, hdlg, 502, NULL, FALSE
               .if eax >= 0 && eax <= 99
                     mov     RightPos, eax
               .endif
                  pop     eax
               .if RightPos != eax
                     add     ChangeOn, 1
               .endif
                  pop     eax
               .if FlatButtons != eax
                     add     ChangeOn, 2
               .endif
               INVOKE     UpdateINI, addr szOptions
            .endif
               mov     eax, TabSelect
            INVOKE     SetFocus, hTabSeL1[eax*4]
         .endif
      .endif

MaintDone:
         mov     eax, FALSE
         ret

MaintDlg ENDP

end start
